#include <system.h>
#include "buspins.h"
#include "common/bus.h"
#include "states.h"
//#include "eeprom.h"

#pragma DATA _CONFIG, _HS_OSC & _CP_OFF & _CPD_OFF & _PWRTE_ON & _WDT_OFF & _MCLRE_OFF & _BOD_ON & _FCMEN_ON
#pragma CLOCK_FREQ 16000000

#define PACKET_TIMEOUT	65000


struct Record lastRecord;
unsigned char recvStatus = 0;
bool commLost = false; // will be set to true if communication is lost with the flight data recorder

extern enum FlightState state;

// blinks a value out, right to left, in decimal
void blink_value(unsigned short val)
{
	unsigned short mod_val = 0;
	unsigned char i = 0;
	
	while (val != 0)
	{
		mod_val = val % 10;
		
		AMBER_LED = 1;
		
		for (i = 0; i < mod_val; ++i)
		{
			GREEN_LED = 1;
			delay_ms(250);
			delay_ms(250);
			delay_ms(250);
			GREEN_LED = 0;
			delay_ms(250);
			delay_ms(250);
			delay_ms(250);
		}
		
		AMBER_LED = 0;
		
		delay_s(2);
		val /= 10;
	}
}

void main()
{
	// disable A/D on all pins
	ansel1 = 0;
	ansel = 0;
	
	trisa.2 = 0;
	trisc.0 = 0;
	trisb.4 = 0;
	trisb.5 = 0;
	trisb.6 = 0;
	
	SERVO_CTRL = 0;
	IGNITION_CTRL = 0;
	STAGING_CTRL = 0;
	
	AMBER_LED = 1;
	GREEN_LED = 1;
	
	delay_ms(250);
	
	AMBER_LED = 0;
	GREEN_LED = 0;
	
	/*eeprom_write(0, 46);
	eeprom_writeShort(1, 1337);
	unsigned char test1 = eeprom_read(0);
	unsigned short test2 = eeprom_readShort(1);
	
	delay_s(1);
	
	if (test1 == 40)
		AMBER_LED = 1;
		
	if (test2 == 1337)
		GREEN_LED = 1;
		
	while (1)
		;*/
		
	//delay_s(2);
	
	/*while (1)
	{
		AMBER_LED = BUS_CLOCK;
		GREEN_LED = BUS_DATA;
	}*/
	
	state = PREFLIGHT;
		
	unsigned short packetTimeout = 0;
	bool newPacket = false;
	
	while (1)
	{
		AMBER_LED = commLost ? 1 : 0;

		if (BUS_SYNC)
		{
			recvStatus = recvRecord(&lastRecord);
			
			if (recvStatus) // packet successfully received
			{
				packetTimeout = 0;
				commLost = false;
				
				newPacket = true;
				
				GREEN_LED ^= 1;//lastRecord.digital & DEBUG_LED ? 1 : 0;
			}
		}
		else
		{
			++packetTimeout;
			if (packetTimeout > PACKET_TIMEOUT)
				commLost = true;
		}
		
		//GREEN_LED = (GetAltitude(lastRecord) > 10) ? 1 : 0;
		handleStates(newPacket);
		newPacket = false;
	}
	
	AMBER_LED = 0;
	GREEN_LED = 0;
	
	//delay_s(3);
	
	//blink_value(r.digital);
	
//	while (1);

	//delay_s(3);
	
	/*if (!ret)
	{
		while (1)
		{
			GREEN_LED = 0;
			AMBER_LED = 1;
			delay_ms(100);
			AMBER_LED = 0;
			GREEN_LED = 1;
			delay_ms(100);
		}
	}
	else if (r.digital != 73)
	{
		AMBER_LED = 1;
	}
	else if (r.batt074 != 191)
	{
		GREEN_LED = 1;
	}
	else
	{
		GREEN_LED = 1;
		AMBER_LED = 1;
	}
	
	while(1);*/
}
