#include "record.h"

uint8_t calcChecksum(const struct Record * rec)
{
	// NOTE: this function makes the assumption that the checksum is the last byte of the struct
	uint8_t * data = (uint8_t *)rec;
	uint8_t checksum = 0;
	unsigned char i;
	for (i = 0; i < sizeof(struct Record) - 1; ++i)
	{
		checksum ^= data[i];
	}
	
	return checksum;
}

void zeroRecord(struct Record * rec)
{
	unsigned char i;
	unsigned char * z = (unsigned char *)rec;
	
	for (i = 0; i < sizeof(struct Record); ++i)
		 *(z++) = 0;
}
