#include <system.h>
#include "eeprom.h"

void eeprom_write(unsigned char addr, unsigned char data)
{
	/*BSF   STATUS,RP0  ;Bank 1
	BCF   STATUS,RP1  ;
	BSF   EECON1,WREN ;Enable write
	BCF   INTCON,GIE  ;Disable INTs
	BTFSC INTCON,GIE  ;See AN-576
	GOTO  $-2         ;
	MOVLW 55h         ;Unlock write
	MOVWF EECON2      ;
	MOVLW AAh         ;
	MOVWF EECON2      ;
	BSF   EECON1,WR   ;Start the write
	BSF   INTCON,GIE  ;Enable INTs
	*/
	
	eeadr = addr;
	eedata = data;
	
	//bit interrupt_status = test_bit(intcon, GIE);
	
	set_bit(eecon1, WREN);
	clear_bit(intcon, GIE);
	
	asm
	{
		movlw 55h
		movwf _eecon2
		movlw AAh
		movwf _eecon2
		bsf _eecon1, WR
	}
	
	clear_bit(eecon1, WREN);
	
	while (test_bit(eecon1, WR))
		;
	
	//if (interrupt_status)
	set_bit(intcon, GIE);
}

unsigned char eeprom_read(unsigned char addr)
{
	/*BSF   STATUS,RP0  ;Bank 1
	BCF   STATUS,RP1  ;
	MOVLW CONFIG_ADDR ;
	MOVWF EEADR       ;Address to read
	BSF   EECON1,RD   ;EE Read
	MOVF  EEDAT,W     ;Move data to W
	*/

	eeadr = addr;
	set_bit(eecon1, RD);
	
	return eedata;
}

void eeprom_writeShort(unsigned char addr, unsigned short data)
{
	eeprom_write(addr, data & 0xFF);
	eeprom_write(addr + 1, data >> 8);
}

unsigned short eeprom_readShort(unsigned char addr)
{
	unsigned short val = 0;
	
	val = eeprom_read(addr + 1);
	val <<= 8;
	val |= eeprom_read(addr);
	
	return val;
}
