#include <system.h>

#pragma DATA _CONFIG, _INTRC_OSC_NOCLKOUT & _CP_OFF & _CPD_OFF & _PWRTE_OFF & _WDT_OFF & _MCLRE_OFF & _BODEN_OFF
#pragma CLOCK_FREQ 4000000

void main()
{
	trisio = 0; // all pins outputs
	ansel = 0; // disable A/D
	gpio = 0; // all pins low
	
	cmcon |= 0x7; // turn off comparator
	
	// retrieve ocscal and set it
	asm
	{
		bsf _status, RP0  	; Bank 1
		call 0x3ff 	; Get the cal value
		movwf _osccal 	; Calibrate
		bcf _status, RP0 	; Bank 0
	}
	
	clear_bit(option_reg, T0CS); // TMR0 operates on internal clock
	//clear_wdt();
	/*clear_bit(option_reg, PSA); // prescaler is not assigned to TMR0
	
	// set prescaler to 110 (1:128, approx every 30ms)
	set_bit(option_reg, PS2);
	clear_bit(option_reg, PS1);
	set_bit(option_reg, PS0);
	*/
	//set_bit(intcon, GIE);
	
	//set_bit(intcon, T0IE); //enable TMR0 overflow bit   
	
	//set_bit(trisio, GPIO2); // make IO pin 2 an input
	
	tmr0 = 255 - 27;
	
	while (1)
	{
		asm
		{
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			bsf _gpio, GP5;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			nop;
			bcf _gpio, GP5;
		}
	}
	
}

void interrupt( void )
{
	clear_bit(intcon, T0IF);
	tmr0 = 255 - 25;
	gpio.5 ^= 1;
}
