#include <system.h>

#pragma DATA _CONFIG, _INTRC_OSC_NOCLKOUT & _CP_OFF & _PWRTE_ON & _WDT_OFF & _MCLRE_OFF & _BODEN_ON
#pragma CLOCK_FREQ 4000000

#define NICHROME	gpio.5
#define MAS_SIGNAL	gpio.2
#define MC2_SIGNAL	gpio.1
#define LED			gpio.4

#define LED_BLINK_RATE	4000
#define SIGNAL_TIMEOUT	2000

void main()
{
	ansel = 0;
	cmcon = 0x07;
	
	trisio.4 = 0;
	trisio.5 = 0;
	
	NICHROME = 0;
	
	clear_bit(option_reg, NOT_GPPU);
	
	// retrieve ocscal and set it
	/*asm
	{
		bsf _status, RP0  	; Bank 1
		call 0x3ff 	; Get the cal value
		movwf _osccal 	; Calibrate
		bcf _status, RP0 	; Bank 0
	}*/
	
	unsigned short counter = 0;
	unsigned short signalTimeout = 0;

	while (1)
	{
		// check for signal from either MAS or MC2
		if (MAS_SIGNAL || !MC2_SIGNAL)
			++signalTimeout;
		else
			signalTimeout = 0;
					
		if (signalTimeout >= SIGNAL_TIMEOUT) // if signal has been active long enough to trigger, trigger nichrome
		{
			delay_ms(250);
			delay_ms(250);
			NICHROME = 1;
			LED = 1;
			delay_s(2);
			NICHROME = 0;
			LED = 0;
			signalTimeout = 0;
		}
			
		// blink the LED
		++counter;
		if (counter >= LED_BLINK_RATE)
		{
			LED ^= 1;
			counter = 0;
		}
		
		//clear_wdt();
	}
}
