#include <system.h>
#include "serial.h"
#include "common/bus.h"
#include "buspins.h"

#pragma DATA _CONFIG, _HS_OSC & _CP_OFF & _CPD_OFF & _PWRTE_ON & _WDT_OFF & _MCLRE_OFF & _BODEN_ON
#pragma CLOCK_FREQ 16000000

#define PACKET_TIMEOUT	200

struct Record lastRecord;

void sendRecordRS232(const struct Record * rec)
{
	uint8_t * data = (uint8_t *)rec;
	
	unsigned char byteIndex;
	
	puts("RM");
	
	// send each byte of the record
	for (byteIndex = 0; byteIndex < sizeof(struct Record); ++byteIndex)
	{
		putch(data[byteIndex]);
	}
}

void main()
{
	ansel = 0;
	cmcon = 0x07;
	
	serialInit();
	
	unsigned char recvStatus = 0;
	unsigned char packetTimeout = 0;
	bool commLost = false;
	
	while (1)
	{
		if (BUS_SYNC)
		{
			recvStatus = recvRecord(&lastRecord);
			
			if (recvStatus) // packet successfully received
			{
				packetTimeout = 0;
				commLost = false;
				
				sendRecordRS232(&lastRecord);
			}
		}
		else
		{
			++packetTimeout;
			if (packetTimeout > PACKET_TIMEOUT)
			{
				commLost = true;
				packetTimeout = 0;
				zeroRecord(&lastRecord);
				lastRecord.digital |= NO_DATA;
				
				lastRecord.checksum = calcChecksum(&lastRecord);
				
				sendRecordRS232(&lastRecord);
			}
			else
				delay_ms(1);
		}
	}

}
